/*
 * Copyright (c) 2022 Qualcomm Innovation Center, Inc. All rights reserved.
 *
 * Permission to use, copy, modify, and/or distribute this software for
 * any purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
 * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

/**
 * DOC: wlan_twt_ext_type.h
 *
 * This header file is included by the converged twt
 * component to map legacy structures to the external
 * (ext)typedefs used by the converged code.
 */

#ifndef __WLAN_TWT_EXT_TYPE_H__
#define __WLAN_TWT_EXT_TYPE_H__

/**
 * typedef psoc_twt_ext_cfg_params_t  - Definition of psoc twt cfg params
 * Define twt cfg params from external umac/twt component point to this type
 */
typedef struct twt_mc_cfg_params psoc_twt_ext_cfg_params_t;

#endif /* __WLAN_TWT_EXT_TYPE_H__ */

